=== modified file '.bzrignore'
--- .bzrignore	2012-05-17 01:55:58 +0000
+++ .bzrignore	2010-09-30 06:24:20 +0000
@@ -3,7 +3,6 @@
 *.8mandos
 confdir
 keydir
-statedir
 man
 plugin-runner
 plugins.d/askpass-fifo

=== modified file 'Makefile'
--- Makefile	2012-06-01 18:39:03 +0000
+++ Makefile	2012-01-15 21:07:44 +0000
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.5.5
+version=1.5.3
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
@@ -71,10 +71,8 @@
 	 /usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
 	$(notdir $<); \
 	$(MANPOST) $(notdir $@);\
-	if locale --all | grep --regexp='^en_US\.utf8$$' && type man \
-	2>/dev/null; then LANG=en_US.UTF-8 MANWIDTH=80 man \
-	--warnings --encoding=UTF-8 --local-file $(notdir $@); fi \
-	>/dev/null)
+	LANG=en_US.UTF-8 MANWIDTH=80 man --warnings --encoding=UTF-8 \
+	--local-file $(notdir $@) >/dev/null)
 # DocBook-to-man post-processing to fix a '\n' escape bug
 MANPOST=$(SED) --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
 
@@ -266,7 +264,7 @@
 	./mandos-keygen --dir keydir --force
 
 # Run the server with a local config
-run-server: confdir/mandos.conf confdir/clients.conf statedir
+run-server: confdir/mandos.conf confdir/clients.conf
 	./mandos --debug --no-dbus --configdir=confdir \
 		--statedir=statedir $(SERVERARGS)
 

=== modified file 'NEWS'
--- NEWS	2012-06-01 18:39:03 +0000
+++ NEWS	2012-01-15 21:07:44 +0000
@@ -1,22 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.5.5 (2012-06-01)
-* Server
-** Server takes new --socket option
-
-Version 1.5.4 (2012-05-20)
-* Server
-** Bug fix: Regression fix: Make non-zero approval timeout values work.
-** Bug fix: Regression fix: Allow changing the Timeout D-Bus property.
-** Fall back to not bind to an interface if an invalid interface name
-   is given.
-** Removed support for undocumented feature of using plain "%%s" in
-   "checker" client option.
-** Old D-Bus interface are now marked as deprecated.
-** mandos-monitor: Bug fix: show approval timers correctly.
-** mandos-ctl: Show "Extended Timeout" correctly, not as milliseconds.
-
 Version 1.5.3 (2012-01-15)
 * Server
 ** Add D-Bus property se.recompile.Client.LastCheckerStatus and use it

=== modified file 'TODO'
--- TODO	2012-05-26 22:21:17 +0000
+++ TODO	2012-05-01 20:48:00 +0000
@@ -40,6 +40,7 @@
 ** TODO [#B] Use openat()
 
 * mandos (server)
+** TODO Document why we ignore sigint
 ** TODO [#B] Log level							  :BUGS:
 *** TODO /etc/mandos/clients.d/*.conf
     Watch this directory and add/remove/update clients?
@@ -48,11 +49,14 @@
    SetLogLevel D-Bus call
 ** TODO Implement --foreground						  :BUGS:
    [[info:standards:Option%20Table][Table of Long Options]]
+** TODO Implement --socket
+   [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO [#C] DBusServiceObjectUsingSuper
 ** TODO [#B] Global enable/disable flag
 ** TODO [#B] By-client countdown on number of secrets given
 ** TODO [#B] Support RFC 3339 time duration syntax
-** D-Bus Client method NeedsPassword(50) - Timeout, default disapprove
+** More D-Bus methods
+*** NeedsPassword(50) - Timeout, default disapprove
     + SetPass(u"gazonk", True) -> Approval, persistent
     + Approve(False) -> Close client connection immediately
 ** TODO [#C] python-parsedatetime
@@ -77,6 +81,8 @@
 ** TODO CheckerCompleted method, deprecate CheckedOK
 ** TODO Secret Service API?
    http://standards.freedesktop.org/secret-service/
+** TODO [[info:python:What's%20New%20in%20Python%202%206][What's New in Python 2.6]]
+*** Start at [[info:python:PEP%203101%20Advanced%20String%20Formatting][PEP 3101 Advanced String Formatting]]
 
 * mandos.xml
 ** Add mandos contact info in manual pages

=== modified file 'common.ent'
--- common.ent	2012-06-01 18:39:03 +0000
+++ common.ent	2012-01-15 21:07:44 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.5.5">
+<!ENTITY version "1.5.3">

=== modified file 'debian/changelog'
--- debian/changelog	2012-06-01 18:39:03 +0000
+++ debian/changelog	2012-02-21 21:20:12 +0000
@@ -1,25 +1,3 @@
-mandos (1.5.5-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/copyright (Format): Updated to
-    "http://www.debian.org/doc/packaging-manuals/copyright-format/1.0/".
-  * debian/control (Build-Depends): Removed "man, locales-all".
-
- -- Teddy Hogeborn <teddy@recompile.se>  Fri, 01 Jun 2012 20:30:41 +0200
-
-mandos (1.5.4-1) unstable; urgency=low
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 20 May 2012 15:38:34 +0200
-
-mandos (1.5.3-1.2) unstable; urgency=low
-
-  * Non-maintainer upload.
-  * Set Architecture to linux-any.  (Closes: #647670)
-
- -- Robert Millan <rmh@debian.org>  Sun, 22 Apr 2012 16:22:01 +0200
-
 mandos (1.5.3-1.1) unstable; urgency=low
 
   * Non-maintainer upload.

=== modified file 'debian/control'
--- debian/control	2012-05-24 18:10:10 +0000
+++ debian/control	2012-02-21 21:20:12 +0000
@@ -6,8 +6,8 @@
 	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
-	pkg-config
-Standards-Version: 3.9.3
+	pkg-config, man, locales-all
+Standards-Version: 3.9.2
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
 Homepage: http://www.recompile.se/mandos
@@ -36,7 +36,7 @@
  whereupon the computers can continue booting normally.
 
 Package: mandos-client
-Architecture: linux-any
+Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
 	gnupg (<< 2), initramfs-tools
 Breaks: dropbear (<= 0.53.1-1)

=== modified file 'debian/copyright'
--- debian/copyright	2012-06-01 21:48:12 +0000
+++ debian/copyright	2011-12-31 23:05:34 +0000
@@ -1,11 +1,11 @@
-Format: http://www.debian.org/doc/packaging-manuals/copyright-format/1.0/
+Format: http://anonscm.debian.org/viewvc/dep/web/deps/dep5.mdwn?revision=202
 Upstream-Name: Mandos
 Upstream-Contact: Mandos <mandos@recompile.se>
 Source: <http://www.recompile.se/mandos>
 
 Files: *
 Copyright: Copyright © 2008-2012 Teddy Hogeborn
-	   Copyright © 2008-2012 Björn Påhlsson
+Copyright: Copyright © 2008-2012 Björn Påhlsson
 License: GPL-3+
     This program is free software: you can redistribute it and/or
     modify it under the terms of the GNU General Public License as

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2012-06-01 21:48:12 +0000
+++ debian/mandos-client.README.Debian	2012-01-01 04:52:07 +0000
@@ -56,7 +56,7 @@
   the interface (see mandos-client(8mandos)) and placing it in
   "/etc/mandos/network-hooks.d", from where it will be copied into the
   initial RAM disk.  Example network hook scripts can be found in
-  "/usr/share/doc/mandos-client/examples/network-hooks.d".
+  "/usr/share/doc/mandos-client/network-hooks.d".
 
 * User-Supplied Plugins
   
@@ -90,4 +90,4 @@
   work, "--options-for=mandos-client:--connect=<ADDRESS>:<PORT>" needs
   to be manually added to the file "/etc/mandos/plugin-runner.conf".
 
- -- Teddy Hogeborn <teddy@recompile.se>, Fri,  1 Jun 2012 23:46:13 +0200
+ -- Teddy Hogeborn <teddy@recompile.se>, Mon, 28 Nov 2011 23:07:22 +0100

=== modified file 'debian/mandos-client.docs'
--- debian/mandos-client.docs	2012-06-01 21:48:12 +0000
+++ debian/mandos-client.docs	2011-11-27 02:32:20 +0000
@@ -1,3 +1,4 @@
 NEWS
 README
 TODO
+network-hooks.d

=== removed file 'debian/mandos-client.examples'
--- debian/mandos-client.examples	2012-06-01 21:48:12 +0000
+++ debian/mandos-client.examples	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
-network-hooks.d

=== modified file 'debian/rules'
--- debian/rules	2012-06-01 21:48:12 +0000
+++ debian/rules	2012-02-21 21:20:12 +0000
@@ -79,7 +79,6 @@
 	dh_testroot
 	dh_installchangelogs
 	dh_installdocs
-	dh_installexamples
 	dh_link
 	dh_strip
 	dh_compress
@@ -87,7 +86,7 @@
 		--exclude etc/mandos/clients.conf \
 		--exclude etc/mandos/plugins.d \
 		--exclude usr/lib/mandos/plugins.d \
-		--exclude usr/share/doc/mandos-client/examples/network-hooks.d
+		--exclude usr/share/doc/mandos-client/network-hooks.d
 	dh_installdeb
 	dh_shlibdeps
 	dh_gencontrol

=== modified file 'init.d-mandos'
--- init.d-mandos	2012-06-01 21:48:12 +0000
+++ init.d-mandos	2011-10-05 16:00:56 +0000
@@ -149,9 +149,6 @@
 		;;
 	esac
 	;;
-  status)
-	status_of_proc "$DAEMON" "$NAME" -p "$PIDFILE"
-	;;
   *)
 	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
 	echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2

=== modified file 'mandos'
--- mandos	2012-06-01 18:39:03 +0000
+++ mandos	2012-05-03 19:06:02 +0000
@@ -34,8 +34,6 @@
 from __future__ import (division, absolute_import, print_function,
                         unicode_literals)
 
-from future_builtins import *
-
 import SocketServer as socketserver
 import socket
 import argparse
@@ -88,7 +86,7 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
-version = "1.5.5"
+version = "1.5.3"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
@@ -151,7 +149,7 @@
     def __enter__(self):
         return self
     
-    def __exit__(self, exc_type, exc_value, traceback):
+    def __exit__ (self, exc_type, exc_value, traceback):
         self._cleanup()
         return False
     
@@ -211,6 +209,7 @@
         return decrypted_plaintext
 
 
+
 class AvahiError(Exception):
     def __init__(self, value, *args, **kwargs):
         self.value = value
@@ -245,7 +244,6 @@
     server: D-Bus Server
     bus: dbus.SystemBus()
     """
-    
     def __init__(self, interface = avahi.IF_UNSPEC, name = None,
                  servicetype = None, port = None, TXT = None,
                  domain = "", host = "", max_renames = 32768,
@@ -264,7 +262,6 @@
         self.server = None
         self.bus = bus
         self.entry_group_state_changed_match = None
-    
     def rename(self):
         """Derived from the Avahi example code"""
         if self.rename_count >= self.max_renames:
@@ -284,7 +281,6 @@
             self.cleanup()
             os._exit(1)
         self.rename_count += 1
-    
     def remove(self):
         """Derived from the Avahi example code"""
         if self.entry_group_state_changed_match is not None:
@@ -292,7 +288,6 @@
             self.entry_group_state_changed_match = None
         if self.group is not None:
             self.group.Reset()
-    
     def add(self):
         """Derived from the Avahi example code"""
         self.remove()
@@ -315,7 +310,6 @@
             dbus.UInt16(self.port),
             avahi.string_array_to_txt_array(self.TXT))
         self.group.Commit()
-    
     def entry_group_state_changed(self, state, error):
         """Derived from the Avahi example code"""
         logger.debug("Avahi entry group state change: %i", state)
@@ -330,7 +324,6 @@
                             unicode(error))
             raise AvahiGroupError("State changed: {0!s}"
                                   .format(error))
-    
     def cleanup(self):
         """Derived from the Avahi example code"""
         if self.group is not None:
@@ -341,7 +334,6 @@
                 pass
             self.group = None
         self.remove()
-    
     def server_state_changed(self, state, error=None):
         """Derived from the Avahi example code"""
         logger.debug("Avahi server state change: %i", state)
@@ -366,7 +358,6 @@
                 logger.debug("Unknown state: %r", state)
             else:
                 logger.debug("Unknown state: %r: %r", state, error)
-    
     def activate(self):
         """Derived from the Avahi example code"""
         if self.server is None:
@@ -379,7 +370,6 @@
                                  self.server_state_changed)
         self.server_state_changed(self.server.GetState())
 
-
 class AvahiServiceToSyslog(AvahiService):
     def rename(self):
         """Add the new name to the syslog messages"""
@@ -390,14 +380,12 @@
                                 .format(self.name)))
         return ret
 
-
 def timedelta_to_milliseconds(td):
     "Convert a datetime.timedelta() to milliseconds"
     return ((td.days * 24 * 60 * 60 * 1000)
             + (td.seconds * 1000)
             + (td.microseconds // 1000))
-
-
+        
 class Client(object):
     """A representation of a client host served by this server.
     
@@ -442,9 +430,8 @@
     """
     
     runtime_expansions = ("approval_delay", "approval_duration",
-                          "created", "enabled", "expires",
-                          "fingerprint", "host", "interval",
-                          "last_approval_request", "last_checked_ok",
+                          "created", "enabled", "fingerprint",
+                          "host", "interval", "last_checked_ok",
                           "last_enabled", "name", "timeout")
     client_defaults = { "timeout": "5m",
                         "extended_timeout": "15m",
@@ -471,7 +458,7 @@
     
     def approval_delay_milliseconds(self):
         return timedelta_to_milliseconds(self.approval_delay)
-    
+
     @staticmethod
     def config_parser(config):
         """Construct a new dict of client settings of this form:
@@ -518,8 +505,12 @@
             client["last_checker_status"] = -2
         
         return settings
-    
+        
+        
     def __init__(self, settings, name = None):
+        """Note: the 'checker' key in 'config' sets the
+        'checker_command' attribute and *not* the 'checker'
+        attribute."""
         self.name = name
         # adding all client settings
         for setting, value in settings.iteritems():
@@ -534,7 +525,7 @@
         else:
             self.last_enabled = None
             self.expires = None
-        
+       
         logger.debug("Creating client %r", self.name)
         # Uppercase and remove spaces from fingerprint for later
         # comparison purposes with return value from the fingerprint()
@@ -542,7 +533,7 @@
         logger.debug("  Fingerprint: %s", self.fingerprint)
         self.created = settings.get("created",
                                     datetime.datetime.utcnow())
-        
+
         # attributes specific for this server instance
         self.checker = None
         self.checker_initiator_tag = None
@@ -576,29 +567,29 @@
         if getattr(self, "enabled", False):
             # Already enabled
             return
+        self.send_changedstate()
         self.expires = datetime.datetime.utcnow() + self.timeout
         self.enabled = True
         self.last_enabled = datetime.datetime.utcnow()
         self.init_checker()
-        self.send_changedstate()
     
     def disable(self, quiet=True):
         """Disable this client."""
         if not getattr(self, "enabled", False):
             return False
         if not quiet:
+            self.send_changedstate()
+        if not quiet:
             logger.info("Disabling client %s", self.name)
-        if getattr(self, "disable_initiator_tag", None) is not None:
+        if getattr(self, "disable_initiator_tag", False):
             gobject.source_remove(self.disable_initiator_tag)
             self.disable_initiator_tag = None
         self.expires = None
-        if getattr(self, "checker_initiator_tag", None) is not None:
+        if getattr(self, "checker_initiator_tag", False):
             gobject.source_remove(self.checker_initiator_tag)
             self.checker_initiator_tag = None
         self.stop_checker()
         self.enabled = False
-        if not quiet:
-            self.send_changedstate()
         # Do not run this again if called by a gobject.timeout_add
         return False
     
@@ -608,14 +599,10 @@
     def init_checker(self):
         # Schedule a new checker to be started an 'interval' from now,
         # and every interval from then on.
-        if self.checker_initiator_tag is not None:
-            gobject.source_remove(self.checker_initiator_tag)
         self.checker_initiator_tag = (gobject.timeout_add
                                       (self.interval_milliseconds(),
                                        self.start_checker))
         # Schedule a disable() when 'timeout' has passed
-        if self.disable_initiator_tag is not None:
-            gobject.source_remove(self.disable_initiator_tag)
         self.disable_initiator_tag = (gobject.timeout_add
                                    (self.timeout_milliseconds(),
                                     self.disable))
@@ -652,7 +639,6 @@
             timeout = self.timeout
         if self.disable_initiator_tag is not None:
             gobject.source_remove(self.disable_initiator_tag)
-            self.disable_initiator_tag = None
         if getattr(self, "enabled", False):
             self.disable_initiator_tag = (gobject.timeout_add
                                           (timedelta_to_milliseconds
@@ -668,10 +654,10 @@
         If a checker already exists, leave it running and do
         nothing."""
         # The reason for not killing a running checker is that if we
-        # did that, and if a checker (for some reason) started running
-        # slowly and taking more than 'interval' time, then the client
-        # would inevitably timeout, since no checker would get a
-        # chance to run to completion.  If we instead leave running
+        # did that, then if a checker (for some reason) started
+        # running slowly and taking more than 'interval' time, the
+        # client would inevitably timeout, since no checker would get
+        # a chance to run to completion.  If we instead leave running
         # checkers alone, the checker would have to take more time
         # than 'timeout' for the client to be disabled, which is as it
         # should be.
@@ -691,17 +677,25 @@
                                       self.current_checker_command)
         # Start a new checker if needed
         if self.checker is None:
-            # Escape attributes for the shell
-            escaped_attrs = dict(
-                (attr, re.escape(unicode(getattr(self, attr))))
-                for attr in
-                self.runtime_expansions)
             try:
-                command = self.checker_command % escaped_attrs
-            except TypeError as error:
-                logger.error('Could not format string "%s"',
-                             self.checker_command, exc_info=error)
-                return True # Try again later
+                # In case checker_command has exactly one % operator
+                command = self.checker_command % self.host
+            except TypeError:
+                # Escape attributes for the shell
+                escaped_attrs = dict(
+                    (attr,
+                     re.escape(unicode(str(getattr(self, attr, "")),
+                                       errors=
+                                       'replace')))
+                    for attr in
+                    self.runtime_expansions)
+                
+                try:
+                    command = self.checker_command % escaped_attrs
+                except TypeError as error:
+                    logger.error('Could not format string "%s"',
+                                 self.checker_command, exc_info=error)
+                    return True # Try again later
             self.current_checker_command = command
             try:
                 logger.info("Starting checker %r for %s",
@@ -713,19 +707,19 @@
                 self.checker = subprocess.Popen(command,
                                                 close_fds=True,
                                                 shell=True, cwd="/")
+                self.checker_callback_tag = (gobject.child_watch_add
+                                             (self.checker.pid,
+                                              self.checker_callback,
+                                              data=command))
+                # The checker may have completed before the gobject
+                # watch was added.  Check for this.
+                pid, status = os.waitpid(self.checker.pid, os.WNOHANG)
+                if pid:
+                    gobject.source_remove(self.checker_callback_tag)
+                    self.checker_callback(pid, status, command)
             except OSError as error:
                 logger.error("Failed to start subprocess",
                              exc_info=error)
-            self.checker_callback_tag = (gobject.child_watch_add
-                                         (self.checker.pid,
-                                          self.checker_callback,
-                                          data=command))
-            # The checker may have completed before the gobject
-            # watch was added.  Check for this.
-            pid, status = os.waitpid(self.checker.pid, os.WNOHANG)
-            if pid:
-                gobject.source_remove(self.checker_callback_tag)
-                self.checker_callback(pid, status, command)
         # Re-run this periodically if run by gobject.timeout_add
         return True
     
@@ -779,7 +773,7 @@
 
 
 def dbus_interface_annotations(dbus_interface):
-    """Decorator for marking functions returning interface annotations
+    """Decorator for marking functions returning interface annotations.
     
     Usage:
     
@@ -982,12 +976,12 @@
                             tag.appendChild(ann_tag)
                 # Add interface annotation tags
                 for annotation, value in dict(
-                    itertools.chain.from_iterable(
-                        annotations().iteritems()
-                        for name, annotations in
-                        self._get_all_dbus_things("interface")
-                        if name == if_tag.getAttribute("name")
-                        )).iteritems():
+                    itertools.chain(
+                        *(annotations().iteritems()
+                          for name, annotations in
+                          self._get_all_dbus_things("interface")
+                          if name == if_tag.getAttribute("name")
+                          ))).iteritems():
                     ann_tag = document.createElement("annotation")
                     ann_tag.setAttribute("name", annotation)
                     ann_tag.setAttribute("value", value)
@@ -1016,7 +1010,7 @@
         return xmlstring
 
 
-def datetime_to_dbus(dt, variant_level=0):
+def datetime_to_dbus (dt, variant_level=0):
     """Convert a UTC datetime.datetime() to a D-Bus type."""
     if dt is None:
         return dbus.String("", variant_level = variant_level)
@@ -1024,48 +1018,32 @@
                        variant_level=variant_level)
 
 
-def alternate_dbus_interfaces(alt_interface_names, deprecate=True):
-    """A class decorator; applied to a subclass of
-    dbus.service.Object, it will add alternate D-Bus attributes with
-    interface names according to the "alt_interface_names" mapping.
-    Usage:
-    
-    @alternate_dbus_interfaces({"org.example.Interface":
-                                    "net.example.AlternateInterface"})
-    class SampleDBusObject(dbus.service.Object):
-        @dbus.service.method("org.example.Interface")
-        def SampleDBusMethod():
-            pass
-    
-    The above "SampleDBusMethod" on "SampleDBusObject" will be
-    reachable via two interfaces: "org.example.Interface" and
-    "net.example.AlternateInterface", the latter of which will have
-    its D-Bus annotation "org.freedesktop.DBus.Deprecated" set to
-    "true", unless "deprecate" is passed with a False value.
-    
-    This works for methods and signals, and also for D-Bus properties
-    (from DBusObjectWithProperties) and interfaces (from the
-    dbus_interface_annotations decorator).
+class AlternateDBusNamesMetaclass(DBusObjectWithProperties
+                                  .__metaclass__):
+    """Applied to an empty subclass of a D-Bus object, this metaclass
+    will add additional D-Bus attributes matching a certain pattern.
     """
-    def wrapper(cls):
-        for orig_interface_name, alt_interface_name in (
-            alt_interface_names.iteritems()):
-            attr = {}
-            interface_names = set()
-            # Go though all attributes of the class
-            for attrname, attribute in inspect.getmembers(cls):
+    def __new__(mcs, name, bases, attr):
+        # Go through all the base classes which could have D-Bus
+        # methods, signals, or properties in them
+        old_interface_names = []
+        for base in (b for b in bases
+                     if issubclass(b, dbus.service.Object)):
+            # Go though all attributes of the base class
+            for attrname, attribute in inspect.getmembers(base):
                 # Ignore non-D-Bus attributes, and D-Bus attributes
                 # with the wrong interface name
                 if (not hasattr(attribute, "_dbus_interface")
                     or not attribute._dbus_interface
-                    .startswith(orig_interface_name)):
+                    .startswith("se.recompile.Mandos")):
                     continue
                 # Create an alternate D-Bus interface name based on
                 # the current name
                 alt_interface = (attribute._dbus_interface
-                                 .replace(orig_interface_name,
-                                          alt_interface_name))
-                interface_names.add(alt_interface)
+                                 .replace("se.recompile.Mandos",
+                                          "se.bsnet.fukt.Mandos"))
+                if alt_interface != attribute._dbus_interface:
+                    old_interface_names.append(alt_interface)
                 # Is this a D-Bus signal?
                 if getattr(attribute, "_dbus_is_signal", False):
                     # Extract the original non-method function by
@@ -1093,9 +1071,8 @@
                     except AttributeError:
                         pass
                     # Define a creator of a function to call both the
-                    # original and alternate functions, so both the
-                    # original and alternate signals gets sent when
-                    # the function is called
+                    # old and new functions, so both the old and new
+                    # signals gets sent when the function is called
                     def fixscope(func1, func2):
                         """This function is a scope container to pass
                         func1 and func2 to the "call_both" function
@@ -1108,7 +1085,8 @@
                         return call_both
                     # Create the "call_both" function and add it to
                     # the class
-                    attr[attrname] = fixscope(attribute, new_function)
+                    attr[attrname] = fixscope(attribute,
+                                              new_function)
                 # Is this a D-Bus method?
                 elif getattr(attribute, "_dbus_is_method", False):
                     # Create a new, but exactly alike, function
@@ -1170,31 +1148,21 @@
                                         attribute.func_name,
                                         attribute.func_defaults,
                                         attribute.func_closure)))
-            if deprecate:
-                # Deprecate all alternate interfaces
-                iname="_AlternateDBusNames_interface_annotation{0}"
-                for interface_name in interface_names:
-                    @dbus_interface_annotations(interface_name)
-                    def func(self):
-                        return { "org.freedesktop.DBus.Deprecated":
-                                     "true" }
-                    # Find an unused name
-                    for aname in (iname.format(i)
-                                  for i in itertools.count()):
-                        if aname not in attr:
-                            attr[aname] = func
-                            break
-            if interface_names:
-                # Replace the class with a new subclass of it with
-                # methods, signals, etc. as created above.
-                cls = type(b"{0}Alternate".format(cls.__name__),
-                           (cls,), attr)
-        return cls
-    return wrapper
-
-
-@alternate_dbus_interfaces({"se.recompile.Mandos":
-                                "se.bsnet.fukt.Mandos"})
+        # Deprecate all old interfaces
+        basename="_AlternateDBusNamesMetaclass_interface_annotation{0}"
+        for old_interface_name in old_interface_names:
+            @dbus_interface_annotations(old_interface_name)
+            def func(self):
+                return { "org.freedesktop.DBus.Deprecated": "true" }
+            # Find an unused name
+            for aname in (basename.format(i) for i in
+                          itertools.count()):
+                if aname not in attr:
+                    attr[aname] = func
+                    break
+        return type.__new__(mcs, name, bases, attr)
+
+
 class ClientDBus(Client, DBusObjectWithProperties):
     """A Client class using D-Bus
     
@@ -1220,7 +1188,7 @@
                                  ("/clients/" + client_object_name))
         DBusObjectWithProperties.__init__(self, self.bus,
                                           self.dbus_object_path)
-    
+        
     def notifychangeproperty(transform_func,
                              dbus_name, type_func=lambda x: x,
                              variant_level=1):
@@ -1249,6 +1217,7 @@
         
         return property(lambda self: getattr(self, attrname), setter)
     
+    
     expires = notifychangeproperty(datetime_to_dbus, "Expires")
     approvals_pending = notifychangeproperty(dbus.Boolean,
                                              "ApprovalPending",
@@ -1336,11 +1305,12 @@
         return False
     
     def approve(self, value=True):
+        self.send_changedstate()
         self.approved = value
         gobject.timeout_add(timedelta_to_milliseconds
                             (self.approval_duration),
                             self._reset_approved)
-        self.send_changedstate()
+    
     
     ## D-Bus methods, signals & properties
     _interface = "se.recompile.Mandos.Client"
@@ -1530,24 +1500,26 @@
     def Timeout_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.UInt64(self.timeout_milliseconds())
-        old_timeout = self.timeout
         self.timeout = datetime.timedelta(0, 0, 0, value)
-        # Reschedule disabling
+        # Reschedule timeout
         if self.enabled:
             now = datetime.datetime.utcnow()
-            self.expires += self.timeout - old_timeout
-            if self.expires <= now:
+            time_to_die = timedelta_to_milliseconds(
+                (self.last_checked_ok + self.timeout) - now)
+            if time_to_die <= 0:
                 # The timeout has passed
                 self.disable()
             else:
+                self.expires = (now +
+                                datetime.timedelta(milliseconds =
+                                                   time_to_die))
                 if (getattr(self, "disable_initiator_tag", None)
                     is None):
                     return
                 gobject.source_remove(self.disable_initiator_tag)
-                self.disable_initiator_tag = (
-                    gobject.timeout_add(
-                        timedelta_to_milliseconds(self.expires - now),
-                        self.disable))
+                self.disable_initiator_tag = (gobject.timeout_add
+                                              (time_to_die,
+                                               self.disable))
     
     # ExtendedTimeout - property
     @dbus_service_property(_interface, signature="t",
@@ -1632,6 +1604,10 @@
         self._pipe.send(('setattr', name, value))
 
 
+class ClientDBusTransitional(ClientDBus):
+    __metaclass__ = AlternateDBusNamesMetaclass
+
+
 class ClientHandler(socketserver.BaseRequestHandler, object):
     """A class to handle client connections.
     
@@ -1741,9 +1717,9 @@
                     #wait until timeout or approved
                     time = datetime.datetime.now()
                     client.changedstate.acquire()
-                    client.changedstate.wait(
-                        float(timedelta_to_milliseconds(delay)
-                              / 1000))
+                    (client.changedstate.wait
+                     (float(client.timedelta_to_milliseconds(delay)
+                            / 1000)))
                     client.changedstate.release()
                     time2 = datetime.datetime.now()
                     if (time2 - time) >= delay:
@@ -1765,8 +1741,7 @@
                     try:
                         sent = session.send(client.secret[sent_size:])
                     except gnutls.errors.GNUTLSError as error:
-                        logger.warning("gnutls send failed",
-                                       exc_info=error)
+                        logger.warning("gnutls send failed")
                         return
                     logger.debug("Sent: %d, remaining: %d",
                                  sent, len(client.secret)
@@ -1786,8 +1761,7 @@
                 try:
                     session.bye()
                 except gnutls.errors.GNUTLSError as error:
-                    logger.warning("GnuTLS bye failed",
-                                   exc_info=error)
+                    logger.warning("GnuTLS bye failed")
     
     @staticmethod
     def peer_certificate(session):
@@ -1865,7 +1839,8 @@
     def process_request(self, request, address):
         """Start a new process to process the request."""
         proc = multiprocessing.Process(target = self.sub_process_main,
-                                       args = (request, address))
+                                       args = (request,
+                                               address))
         proc.start()
         return proc
 
@@ -1899,42 +1874,12 @@
         use_ipv6:       Boolean; to use IPv6 or not
     """
     def __init__(self, server_address, RequestHandlerClass,
-                 interface=None, use_ipv6=True, socketfd=None):
-        """If socketfd is set, use that file descriptor instead of
-        creating a new one with socket.socket().
-        """
+                 interface=None, use_ipv6=True):
         self.interface = interface
         if use_ipv6:
             self.address_family = socket.AF_INET6
-        if socketfd is not None:
-            # Save the file descriptor
-            self.socketfd = socketfd
-            # Save the original socket.socket() function
-            self.socket_socket = socket.socket
-            # To implement --socket, we monkey patch socket.socket.
-            # 
-            # (When socketserver.TCPServer is a new-style class, we
-            # could make self.socket into a property instead of monkey
-            # patching socket.socket.)
-            # 
-            # Create a one-time-only replacement for socket.socket()
-            @functools.wraps(socket.socket)
-            def socket_wrapper(*args, **kwargs):
-                # Restore original function so subsequent calls are
-                # not affected.
-                socket.socket = self.socket_socket
-                del self.socket_socket
-                # This time only, return a new socket object from the
-                # saved file descriptor.
-                return socket.fromfd(self.socketfd, *args, **kwargs)
-            # Replace socket.socket() function with wrapper
-            socket.socket = socket_wrapper
-        # The socketserver.TCPServer.__init__ will call
-        # socket.socket(), which might be our replacement,
-        # socket_wrapper(), if socketfd was set.
         socketserver.TCPServer.__init__(self, server_address,
                                         RequestHandlerClass)
-    
     def server_bind(self):
         """This overrides the normal server_bind() function
         to bind to an interface if one was specified, and also NOT to
@@ -1951,18 +1896,14 @@
                                            str(self.interface
                                                + '\0'))
                 except socket.error as error:
-                    if error.errno == errno.EPERM:
+                    if error[0] == errno.EPERM:
                         logger.error("No permission to"
                                      " bind to interface %s",
                                      self.interface)
-                    elif error.errno == errno.ENOPROTOOPT:
+                    elif error[0] == errno.ENOPROTOOPT:
                         logger.error("SO_BINDTODEVICE not available;"
                                      " cannot bind to interface %s",
                                      self.interface)
-                    elif error.errno == errno.ENODEV:
-                        logger.error("Interface %s does not"
-                                     " exist, cannot bind",
-                                     self.interface)
                     else:
                         raise
         # Only bind(2) the socket if we really need to.
@@ -1998,7 +1939,7 @@
     """
     def __init__(self, server_address, RequestHandlerClass,
                  interface=None, use_ipv6=True, clients=None,
-                 gnutls_priority=None, use_dbus=True, socketfd=None):
+                 gnutls_priority=None, use_dbus=True):
         self.enabled = False
         self.clients = clients
         if self.clients is None:
@@ -2008,8 +1949,7 @@
         IPv6_TCPServer.__init__(self, server_address,
                                 RequestHandlerClass,
                                 interface = interface,
-                                use_ipv6 = use_ipv6,
-                                socketfd = socketfd)
+                                use_ipv6 = use_ipv6)
     def server_activate(self):
         if self.enabled:
             return socketserver.TCPServer.server_activate(self)
@@ -2028,8 +1968,22 @@
     
     def handle_ipc(self, source, condition, parent_pipe=None,
                    proc = None, client_object=None):
+        condition_names = {
+            gobject.IO_IN: "IN",   # There is data to read.
+            gobject.IO_OUT: "OUT", # Data can be written (without
+                                    # blocking).
+            gobject.IO_PRI: "PRI", # There is urgent data to read.
+            gobject.IO_ERR: "ERR", # Error condition.
+            gobject.IO_HUP: "HUP"  # Hung up (the connection has been
+                                    # broken, usually for pipes and
+                                    # sockets).
+            }
+        conditions_string = ' | '.join(name
+                                       for cond, name in
+                                       condition_names.iteritems()
+                                       if cond & condition)
         # error, or the other end of multiprocessing.Pipe has closed
-        if condition & (gobject.IO_ERR | gobject.IO_HUP):
+        if condition & (gobject.IO_ERR | condition & gobject.IO_HUP):
             # Wait for other process to exit
             proc.join()
             return False
@@ -2196,9 +2150,6 @@
     parser.add_argument("--no-restore", action="store_false",
                         dest="restore", help="Do not restore stored"
                         " state")
-    parser.add_argument("--socket", type=int,
-                        help="Specify a file descriptor to a network"
-                        " socket to use instead of creating one")
     parser.add_argument("--statedir", metavar="DIR",
                         help="Directory to save/restore state in")
     
@@ -2221,7 +2172,6 @@
                         "use_ipv6": "True",
                         "debuglevel": "",
                         "restore": "True",
-                        "socket": "",
                         "statedir": "/var/lib/mandos"
                         }
     
@@ -2239,15 +2189,6 @@
     if server_settings["port"]:
         server_settings["port"] = server_config.getint("DEFAULT",
                                                        "port")
-    if server_settings["socket"]:
-        server_settings["socket"] = server_config.getint("DEFAULT",
-                                                         "socket")
-        # Later, stdin will, and stdout and stderr might, be dup'ed
-        # over with an opened os.devnull.  But we don't want this to
-        # happen with a supplied network socket.
-        if 0 <= server_settings["socket"] <= 2:
-            server_settings["socket"] = os.dup(server_settings
-                                               ["socket"])
     del server_config
     
     # Override the settings from the config file with command line
@@ -2255,7 +2196,7 @@
     for option in ("interface", "address", "port", "debug",
                    "priority", "servicename", "configdir",
                    "use_dbus", "use_ipv6", "debuglevel", "restore",
-                   "statedir", "socket"):
+                   "statedir"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -2309,16 +2250,13 @@
                               use_ipv6=use_ipv6,
                               gnutls_priority=
                               server_settings["priority"],
-                              use_dbus=use_dbus,
-                              socketfd=(server_settings["socket"]
-                                        or None))
+                              use_dbus=use_dbus)
     if not debug:
         pidfilename = "/var/run/mandos.pid"
         try:
             pidfile = open(pidfilename, "w")
-        except IOError as e:
-            logger.error("Could not open file %r", pidfilename,
-                         exc_info=e)
+        except IOError:
+            logger.error("Could not open file %r", pidfilename)
     
     for name in ("_mandos", "mandos", "nobody"):
         try:
@@ -2334,7 +2272,7 @@
         os.setgid(gid)
         os.setuid(uid)
     except OSError as error:
-        if error.errno != errno.EPERM:
+        if error[0] != errno.EPERM:
             raise error
     
     if debug:
@@ -2362,8 +2300,6 @@
         # Close all input and output, do double fork, etc.
         daemon()
     
-    # multiprocessing will use threads, so before we use gobject we
-    # need to inform gobject that threads will be used.
     gobject.threads_init()
     
     global main_loop
@@ -2380,7 +2316,7 @@
                             ("se.bsnet.fukt.Mandos", bus,
                              do_not_queue=True))
         except dbus.exceptions.NameExistsException as e:
-            logger.error("Disabling D-Bus:", exc_info=e)
+            logger.error(unicode(e) + ", disabling D-Bus")
             use_dbus = False
             server_settings["use_dbus"] = False
             tcp_server.use_dbus = False
@@ -2398,7 +2334,8 @@
     
     client_class = Client
     if use_dbus:
-        client_class = functools.partial(ClientDBus, bus = bus)
+        client_class = functools.partial(ClientDBusTransitional,
+                                         bus = bus)
     
     client_settings = Client.config_parser(client_config)
     old_client_settings = {}
@@ -2412,16 +2349,13 @@
                                                      (stored_state))
             os.remove(stored_state_path)
         except IOError as e:
-            if e.errno == errno.ENOENT:
-                logger.warning("Could not load persistent state: {0}"
-                                .format(os.strerror(e.errno)))
-            else:
-                logger.critical("Could not load persistent state:",
-                                exc_info=e)
+            logger.warning("Could not load persistent state: {0}"
+                           .format(e))
+            if e.errno != errno.ENOENT:
                 raise
         except EOFError as e:
             logger.warning("Could not load persistent state: "
-                           "EOFError:", exc_info=e)
+                           "EOFError: {0}".format(e))
     
     with PGPEngine() as pgp:
         for client_name, client in clients_data.iteritems():
@@ -2480,6 +2414,7 @@
                              .format(client_name))
                 client["secret"] = (
                     client_settings[client_name]["secret"])
+
     
     # Add/remove clients based on new changes made to config
     for client_name in (set(old_client_settings)
@@ -2488,7 +2423,7 @@
     for client_name in (set(client_settings)
                         - set(old_client_settings)):
         clients_data[client_name] = client_settings[client_name]
-    
+
     # Create all client objects
     for client_name, client in clients_data.iteritems():
         tcp_server.clients[client_name] = client_class(
@@ -2496,7 +2431,7 @@
     
     if not tcp_server.clients:
         logger.warning("No clients defined")
-    
+        
     if not debug:
         try:
             with pidfile:
@@ -2510,13 +2445,12 @@
             # "pidfile" was never created
             pass
         del pidfilename
+        signal.signal(signal.SIGINT, signal.SIG_IGN)
     
     signal.signal(signal.SIGHUP, lambda signum, frame: sys.exit())
     signal.signal(signal.SIGTERM, lambda signum, frame: sys.exit())
     
     if use_dbus:
-        @alternate_dbus_interfaces({"se.recompile.Mandos":
-                                        "se.bsnet.fukt.Mandos"})
         class MandosDBusService(DBusObjectWithProperties):
             """A D-Bus proxy object"""
             def __init__(self):
@@ -2576,7 +2510,9 @@
             
             del _interface
         
-        mandos_dbus_service = MandosDBusService()
+        class MandosDBusServiceTransitional(MandosDBusService):
+            __metaclass__ = AlternateDBusNamesMetaclass
+        mandos_dbus_service = MandosDBusServiceTransitional()
     
     def cleanup():
         "Cleanup function; run on exit"
@@ -2615,25 +2551,23 @@
                 del client_settings[client.name]["secret"]
         
         try:
-            with (tempfile.NamedTemporaryFile
-                  (mode='wb', suffix=".pickle", prefix='clients-',
-                   dir=os.path.dirname(stored_state_path),
-                   delete=False)) as stored_state:
+            tempfd, tempname = tempfile.mkstemp(suffix=".pickle",
+                                                prefix="clients-",
+                                                dir=os.path.dirname
+                                                (stored_state_path))
+            with os.fdopen(tempfd, "wb") as stored_state:
                 pickle.dump((clients, client_settings), stored_state)
-                tempname=stored_state.name
             os.rename(tempname, stored_state_path)
         except (IOError, OSError) as e:
+            logger.warning("Could not save persistent state: {0}"
+                           .format(e))
             if not debug:
                 try:
                     os.remove(tempname)
                 except NameError:
                     pass
-            if e.errno in (errno.ENOENT, errno.EACCES, errno.EEXIST):
-                logger.warning("Could not save persistent state: {0}"
-                               .format(os.strerror(e.errno)))
-            else:
-                logger.warning("Could not save persistent state:",
-                               exc_info=e)
+            if e.errno not in set((errno.ENOENT, errno.EACCES,
+                                   errno.EEXIST)):
                 raise e
         
         # Delete all clients, and settings from config

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2012-05-26 22:48:45 +0000
+++ mandos-clients.conf.xml	2012-01-01 04:02:00 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2012-05-27">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -167,12 +167,12 @@
 	    This option is <emphasis>optional</emphasis>.
 	  </para>
 	  <para>
-	    This option overrides the default shell command that the
-	    server will use to check if the client is still up.  Any
-	    output of the command will be ignored, only the exit code
-	    is checked:  If the exit code of the command is zero, the
-	    client is considered up.  The command will be run using
-	    <quote><command><filename>/bin/sh</filename>
+	    This option allows you to override the default shell
+	    command that the server will use to check if the client is
+	    still up.  Any output of the command will be ignored, only
+	    the exit code is checked:  If the exit code of the command
+	    is zero, the client is considered up.  The command will be
+	    run using <quote><command><filename>/bin/sh</filename>
 	    <option>-c</option></command></quote>, so
 	    <varname>PATH</varname> will be searched.  The default
 	    value for the checker command is <quote><literal
@@ -409,7 +409,6 @@
 	<quote><literal>approval_duration</literal></quote>,
 	<quote><literal>created</literal></quote>,
 	<quote><literal>enabled</literal></quote>,
-	<quote><literal>expires</literal></quote>,
 	<quote><literal>fingerprint</literal></quote>,
 	<quote><literal>host</literal></quote>,
 	<quote><literal>interval</literal></quote>,
@@ -512,8 +511,6 @@
       <citerefentry><refentrytitle>mandos.conf</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>fping</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>
     </para>
   </refsect1>

=== modified file 'mandos-ctl'
--- mandos-ctl	2012-06-01 18:39:03 +0000
+++ mandos-ctl	2012-05-05 09:17:34 +0000
@@ -17,8 +17,7 @@
 #     GNU General Public License for more details.
 # 
 # You should have received a copy of the GNU General Public License
-# along with this program.  If not, see
-# <http://www.gnu.org/licenses/>.
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
 # 
 # Contact the authors at <mandos@recompile.se>.
 # 
@@ -26,8 +25,6 @@
 from __future__ import (division, absolute_import, print_function,
                         unicode_literals)
 
-from future_builtins import *
-
 import sys
 import dbus
 import argparse
@@ -63,7 +60,7 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.5.5"
+version = "1.5.3"
 
 def timedelta_to_milliseconds(td):
     """Convert a datetime.timedelta object to milliseconds"""
@@ -119,7 +116,7 @@
         if type(value) is dbus.Boolean:
             return "Yes" if value else "No"
         if keyword in ("Timeout", "Interval", "ApprovalDelay",
-                       "ApprovalDuration", "ExtendedTimeout"):
+                       "ApprovalDuration"):
             return milliseconds_to_string(value)
         return unicode(value)
     
@@ -210,7 +207,7 @@
     parser.add_argument("client", nargs="*", help="Client name")
     options = parser.parse_args()
     
-    if has_actions(options) and not (options.client or options.all):
+    if has_actions(options) and not options.client and not options.all:
         parser.error("Options require clients names or --all.")
     if options.verbose and has_actions(options):
         parser.error("--verbose can only be used alone or with"

=== modified file 'mandos-keygen'
--- mandos-keygen	2012-06-01 18:39:03 +0000
+++ mandos-keygen	2012-01-15 21:07:44 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.5.5"
+VERSION="1.5.3"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos-monitor'
--- mandos-monitor	2012-06-01 18:39:03 +0000
+++ mandos-monitor	2012-05-03 18:51:48 +0000
@@ -17,8 +17,7 @@
 #     GNU General Public License for more details.
 # 
 # You should have received a copy of the GNU General Public License
-# along with this program.  If not, see
-# <http://www.gnu.org/licenses/>.
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
 # 
 # Contact the authors at <mandos@recompile.se>.
 # 
@@ -26,8 +25,6 @@
 from __future__ import (division, absolute_import, print_function,
                         unicode_literals)
 
-from future_builtins import *
-
 import sys
 import os
 import signal
@@ -55,7 +52,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.5.5"
+version = "1.5.3"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False
@@ -86,26 +83,23 @@
     properties and calls a hook function when any of them are
     changed.
     """
-    def __init__(self, proxy_object=None, properties=None, **kwargs):
+    def __init__(self, proxy_object=None, *args, **kwargs):
         self.proxy = proxy_object # Mandos Client proxy object
-        self.properties = dict() if properties is None else properties
+        
+        self.properties = dict()
         self.property_changed_match = (
             self.proxy.connect_to_signal("PropertyChanged",
-                                         self._property_changed,
+                                         self.property_changed,
                                          client_interface,
                                          byte_arrays=True))
         
-        if properties is None:
-            self.properties.update(
-                self.proxy.GetAll(client_interface,
-                                  dbus_interface
-                                  = dbus.PROPERTIES_IFACE))
-        
-        super(MandosClientPropertyCache, self).__init__(**kwargs)
-    
-    def _property_changed(self, property, value):
-        """Helper which takes positional arguments"""
-        return self.property_changed(property=property, value=value)
+        self.properties.update(
+            self.proxy.GetAll(client_interface,
+                              dbus_interface = dbus.PROPERTIES_IFACE))
+
+        #XXX This breaks good super behaviour
+#        super(MandosClientPropertyCache, self).__init__(
+#            *args, **kwargs)
     
     def property_changed(self, property=None, value=None):
         """This is called whenever we get a PropertyChanged signal
@@ -114,8 +108,10 @@
         # Update properties dict with new value
         self.properties[property] = value
     
-    def delete(self):
+    def delete(self, *args, **kwargs):
         self.property_changed_match.remove()
+        super(MandosClientPropertyCache, self).__init__(
+            *args, **kwargs)
 
 
 class MandosClientWidget(urwid.FlowWidget, MandosClientPropertyCache):
@@ -123,7 +119,7 @@
     """
     
     def __init__(self, server_proxy_object=None, update_hook=None,
-                 delete_hook=None, logger=None, **kwargs):
+                 delete_hook=None, logger=None, *args, **kwargs):
         # Called on update
         self.update_hook = update_hook
         # Called on delete
@@ -134,15 +130,27 @@
         self.logger = logger
         
         self._update_timer_callback_tag = None
+        self._update_timer_callback_lock = 0
         
         # The widget shown normally
         self._text_widget = urwid.Text("")
         # The widget shown when we have focus
         self._focus_text_widget = urwid.Text("")
-        super(MandosClientWidget, self).__init__(**kwargs)
+        super(MandosClientWidget, self).__init__(
+            update_hook=update_hook, delete_hook=delete_hook,
+            *args, **kwargs)
         self.update()
         self.opened = False
         
+        last_checked_ok = isoformat_to_datetime(self.properties
+                                                ["LastCheckedOK"])
+        
+        if self.properties ["LastCheckerStatus"] != 0:
+            self.using_timer(True)
+        
+        if self.need_approval:
+            self.using_timer(True)
+        
         self.match_objects = (
             self.proxy.connect_to_signal("CheckerCompleted",
                                          self.checker_completed,
@@ -167,16 +175,32 @@
         #self.logger('Created client {0}'
         #            .format(self.properties["Name"]))
     
+    def property_changed(self, property=None, value=None):
+        super(self, MandosClientWidget).property_changed(property,
+                                                         value)
+        if property == "ApprovalPending":
+            using_timer(bool(value))
+        if property == "LastCheckerStatus":
+            using_timer(value != 0)
+            #self.logger('Checker for client {0} (command "{1}") was '
+            #            ' successful'.format(self.properties["Name"],
+            #                                 command))
+    
     def using_timer(self, flag):
         """Call this method with True or False when timer should be
         activated or deactivated.
         """
-        if flag and self._update_timer_callback_tag is None:
+        old = self._update_timer_callback_lock
+        if flag:
+            self._update_timer_callback_lock += 1
+        else:
+            self._update_timer_callback_lock -= 1
+        if old == 0 and self._update_timer_callback_lock:
             # Will update the shown timer value every second
             self._update_timer_callback_tag = (gobject.timeout_add
                                                (1000,
                                                 self.update_timer))
-        elif not (flag or self._update_timer_callback_tag is None):
+        elif old and self._update_timer_callback_lock == 0:
             gobject.source_remove(self._update_timer_callback_tag)
             self._update_timer_callback_tag = None
     
@@ -224,6 +248,7 @@
             message = 'Client {0} will get its secret in {1} seconds'
         self.logger(message.format(self.properties["Name"],
                                    timeout/1000))
+        self.using_timer(True)
     
     def rejected(self, reason):
         self.logger('Client {0} was rejected; reason: {1}'
@@ -255,14 +280,13 @@
                           "bold-underline-blink":
                               "bold-underline-blink-standout",
                           }
-        
+
         # Rebuild focus and non-focus widgets using current properties
-        
+
         # Base part of a client. Name!
         base = '{name}: '.format(name=self.properties["Name"])
         if not self.properties["Enabled"]:
             message = "DISABLED"
-            self.using_timer(False)
         elif self.properties["ApprovalPending"]:
             timeout = datetime.timedelta(milliseconds
                                          = self.properties
@@ -270,9 +294,8 @@
             last_approval_request = isoformat_to_datetime(
                 self.properties["LastApprovalRequest"])
             if last_approval_request is not None:
-                timer = max(timeout - (datetime.datetime.utcnow()
-                                       - last_approval_request),
-                            datetime.timedelta())
+                timer = timeout - (datetime.datetime.utcnow()
+                                   - last_approval_request)
             else:
                 timer = datetime.timedelta()
             if self.properties["ApprovedByDefault"]:
@@ -280,26 +303,22 @@
             else:
                 message = "Denial in {0}. (a)pprove?"
             message = message.format(unicode(timer).rsplit(".", 1)[0])
-            self.using_timer(True)
         elif self.properties["LastCheckerStatus"] != 0:
-            # When checker has failed, show timer until client expires
+            # When checker has failed, print a timer until client expires
             expires = self.properties["Expires"]
             if expires == "":
                 timer = datetime.timedelta(0)
             else:
-                expires = (datetime.datetime.strptime
-                           (expires, '%Y-%m-%dT%H:%M:%S.%f'))
-                timer = max(expires - datetime.datetime.utcnow(),
-                            datetime.timedelta())
+                expires = datetime.datetime.strptime(expires,
+                                                     '%Y-%m-%dT%H:%M:%S.%f')
+                timer = expires - datetime.datetime.utcnow()
             message = ('A checker has failed! Time until client'
                        ' gets disabled: {0}'
                        .format(unicode(timer).rsplit(".", 1)[0]))
-            self.using_timer(True)
         else:
             message = "enabled"
-            self.using_timer(False)
         self._text = "{0}{1}".format(base, message)
-        
+            
         if not urwid.supports_unicode():
             self._text = self._text.encode("ascii", "replace")
         textlist = [("normal", self._text)]
@@ -322,7 +341,7 @@
         self.update()
         return True             # Keep calling this
     
-    def delete(self, **kwargs):
+    def delete(self, *args, **kwargs):
         if self._update_timer_callback_tag is not None:
             gobject.source_remove(self._update_timer_callback_tag)
             self._update_timer_callback_tag = None
@@ -331,7 +350,7 @@
         self.match_objects = ()
         if self.delete_hook is not None:
             self.delete_hook(self)
-        return super(MandosClientWidget, self).delete(**kwargs)
+        return super(MandosClientWidget, self).delete(*args, **kwargs)
     
     def render(self, maxcolrow, focus=False):
         """Render differently if we have focus.
@@ -379,13 +398,14 @@
         else:
             return key
     
-    def property_changed(self, property=None, **kwargs):
+    def property_changed(self, property=None, value=None,
+                         *args, **kwargs):
         """Call self.update() if old value is not new value.
         This overrides the method from MandosClientPropertyCache"""
         property_name = unicode(property)
         old_value = self.properties.get(property_name)
         super(MandosClientWidget, self).property_changed(
-            property=property, **kwargs)
+            property=property, value=value, *args, **kwargs)
         if self.properties.get(property_name) != old_value:
             self.update()
 
@@ -395,8 +415,8 @@
     "down" key presses, thus not allowing any containing widgets to
     use them as an excuse to shift focus away from this widget.
     """
-    def keypress(self, *args, **kwargs):
-        ret = super(ConstrainedListBox, self).keypress(*args, **kwargs)
+    def keypress(self, maxcolrow, key):
+        ret = super(ConstrainedListBox, self).keypress(maxcolrow, key)
         if ret in ("up", "down"):
             return
         return ret
@@ -617,7 +637,7 @@
                                                logger
                                                =self.log_message),
                             path=path)
-        
+
         self.refresh()
         self._input_callback_tag = (gobject.io_add_watch
                                     (sys.stdin.fileno(),

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2012-05-26 22:21:17 +0000
+++ mandos-options.xml	2012-01-01 04:02:00 +0000
@@ -97,10 +97,4 @@
     class="directory">/var/lib/mandos</filename></quote>.
   </para>
   
-  <para id="socket">
-    If this option is used, the server will not create a new network
-    socket, but will instead use the supplied file descriptor.  By
-    default, the server will create a new network socket.
-  </para>
-  
 </section>

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2012-05-26 22:21:17 +0000
+++ mandos.conf.xml	2011-12-31 23:05:34 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2012-05-26">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -174,14 +174,6 @@
 	</listitem>
       </varlistentry>
       
-      <varlistentry>
-	<term><option>socket<literal> = </literal><replaceable
-	>NUMBER</replaceable></option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="socket"/>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   

=== modified file 'mandos.lsm'
--- mandos.lsm	2012-06-01 18:39:03 +0000
+++ mandos.lsm	2012-01-15 21:07:44 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.5.5
-Entered-date:	2012-06-01
+Version:	1.5.3
+Entered-date:	2012-01-15
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site: http://www.recompile.se/mandos
-	      148K mandos_1.5.5.orig.tar.gz
+	      147K mandos_1.5.3.orig.tar.gz
 Alternate-site: ftp://ftp.recompile.se/pub/mandos
-		148K mandos_1.5.5.orig.tar.gz
+		147K mandos_1.5.3.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2012-05-26 22:21:17 +0000
+++ mandos.xml	2012-01-15 21:01:13 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2012-05-26">
+<!ENTITY TIMESTAMP "2012-01-15">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -100,9 +100,6 @@
       <sbr/>
       <arg><option>--statedir
       <replaceable>DIRECTORY</replaceable></option></arg>
-      <sbr/>
-      <arg><option>--socket
-      <replaceable>FD</replaceable></option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -302,15 +299,6 @@
 	  <xi:include href="mandos-options.xml" xpointer="statedir"/>
 	</listitem>
       </varlistentry>
-      
-      <varlistentry>
-	<term><option>--socket
-	<replaceable>FD</replaceable></option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="socket"/>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   

=== modified file 'network-hooks.d/wireless'
--- network-hooks.d/wireless	2012-05-25 15:59:39 +0000
+++ network-hooks.d/wireless	2012-04-24 06:55:34 +0000
@@ -35,7 +35,8 @@
     exit
 fi
 
-ifkeys=`sed -n -e 's/^ADDRESS_\([^=]*\)=.*/\1/p' "$CONFIG" | sort -u`
+ifkeys=`env | sed -n -e 's/^ADDRESS_\([^=]*\)=.*/\1/p' "$CONFIG" \
+    | sort -u`
 
 # Exit if DEVICE is set and is not any of the wireless interfaces
 if [ -n "$DEVICE" ]; then

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2012-06-06 19:08:17 +0000
+++ plugins.d/mandos-client.c	2011-12-31 23:05:34 +0000
@@ -41,7 +41,7 @@
 
 #include <stdio.h>		/* fprintf(), stderr, fwrite(),
 				   stdout, ferror(), remove() */
-#include <stdint.h> 		/* uint16_t, uint32_t, intptr_t */
+#include <stdint.h> 		/* uint16_t, uint32_t */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
 #include <stdlib.h> 		/* free(), EXIT_SUCCESS, srand(),
 				   strtof(), abort() */
@@ -135,8 +135,6 @@
 static const char sys_class_net[] = "/sys/class/net";
 char *connect_to = NULL;
 const char *hookdir = HOOKDIR;
-uid_t uid = 65534;
-gid_t gid = 65534;
 
 /* Doubly linked list that need to be circularly linked when used */
 typedef struct server{
@@ -823,11 +821,8 @@
     goto mandos_end;
   }
   
-  /* This casting via intptr_t is to eliminate warning about casting
-     an int to a pointer type.  This is exactly how the GnuTLS Guile
-     function "set-session-transport-fd!" does it. */
-  gnutls_transport_set_ptr(session,
-			   (gnutls_transport_ptr_t)(intptr_t)tcp_sd);
+  /* Spurious warning from -Wint-to-pointer-cast */
+  gnutls_transport_set_ptr(session, (gnutls_transport_ptr_t) tcp_sd);
   
   if(quit_now){
     errno = EINTR;
@@ -1392,49 +1387,6 @@
   }
 }
 
-/* Set effective uid to 0, return errno */
-int raise_privileges(void){
-  int old_errno = errno;
-  int ret_errno = 0;
-  errno = 0;
-  if(seteuid(0) == -1){
-    perror_plus("seteuid");
-  }
-  ret_errno = errno;
-  errno = old_errno;
-  return ret_errno;
-}
-
-/* Set effective and real user ID to 0.  Return errno. */
-int raise_privileges_permanently(void){
-  int old_errno = errno;
-  int ret_errno = raise_privileges();
-  if(ret_errno != 0){
-    errno = old_errno;
-    return ret_errno;
-  }
-  errno = 0;
-  if(setuid(0) == -1){
-    perror_plus("seteuid");
-  }
-  ret_errno = errno;
-  errno = old_errno;
-  return ret_errno;
-}
-
-/* Set effective user ID to unprivileged saved user ID */
-int lower_privileges(void){
-  int old_errno = errno;
-  int ret_errno = 0;
-  errno = 0;
-  if(seteuid(uid) == -1){
-    perror_plus("seteuid");
-  }
-  ret_errno = errno;
-  errno = old_errno;
-  return ret_errno;
-}
-
 bool run_network_hooks(const char *mode, const char *interface,
 		       const float delay){
   struct dirent **direntries;
@@ -1462,7 +1414,17 @@
       if(hook_pid == 0){
 	/* Child */
 	/* Raise privileges */
-	raise_privileges_permanently();
+	errno = 0;
+	ret = seteuid(0);
+	if(ret == -1){
+	  perror_plus("seteuid");
+	}
+	/* Raise privileges even more */
+	errno = 0;
+	ret = setuid(0);
+	if(ret == -1){
+	  perror_plus("setuid");
+	}
 	/* Set group */
 	errno = 0;
 	ret = setgid(0);
@@ -1561,118 +1523,6 @@
   return true;
 }
 
-int bring_up_interface(const char * const interface, const float delay){
-  int sd = -1;
-  int ret;
-  struct ifreq network;
-  AvahiIfIndex if_index = (AvahiIfIndex)if_nametoindex(interface);
-  if(if_index == 0){
-    fprintf_plus(stderr, "No such interface: \"%s\"\n", interface);
-    return EX_UNAVAILABLE;
-  }
-  
-  if(quit_now){
-    return EINTR;
-  }
-  
-  /* Re-raise priviliges */
-  raise_privileges();
-    
-#ifdef __linux__
-  /* Lower kernel loglevel to KERN_NOTICE to avoid KERN_INFO
-     messages about the network interface to mess up the prompt */
-  ret = klogctl(8, NULL, 5);
-  bool restore_loglevel = true;
-  if(ret == -1){
-    restore_loglevel = false;
-    perror_plus("klogctl");
-  }
-#endif	/* __linux__ */
-    
-  sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-  if(sd < 0){
-    perror_plus("socket");
-#ifdef __linux__
-    if(restore_loglevel){
-      ret = klogctl(7, NULL, 0);
-      if(ret == -1){
-	perror_plus("klogctl");
-      }
-    }
-#endif	/* __linux__ */
-    /* Lower privileges */
-    lower_privileges();
-    return EX_OSERR;
-;
-  }
-  strcpy(network.ifr_name, interface);
-  ret = ioctl(sd, SIOCGIFFLAGS, &network);
-  if(ret == -1){
-    perror_plus("ioctl SIOCGIFFLAGS");
-#ifdef __linux__
-    if(restore_loglevel){
-      ret = klogctl(7, NULL, 0);
-      if(ret == -1){
-	perror_plus("klogctl");
-      }
-    }
-#endif	/* __linux__ */
-    /* Lower privileges */
-    lower_privileges();
-    return EX_OSERR;
-  }
-  if((network.ifr_flags & IFF_UP) == 0){
-    network.ifr_flags |= IFF_UP;
-    ret = ioctl(sd, SIOCSIFFLAGS, &network);
-    if(ret == -1){
-      perror_plus("ioctl SIOCSIFFLAGS +IFF_UP");
-#ifdef __linux__
-      if(restore_loglevel){
-	ret = klogctl(7, NULL, 0);
-	if(ret == -1){
-	  perror_plus("klogctl");
-	}
-      }
-#endif	/* __linux__ */
-	/* Lower privileges */
-      lower_privileges();
-      return EX_OSERR;
-    }
-  }
-  /* Sleep checking until interface is running.
-     Check every 0.25s, up to total time of delay */
-  for(int i=0; i < delay * 4; i++){
-    ret = ioctl(sd, SIOCGIFFLAGS, &network);
-    if(ret == -1){
-      perror_plus("ioctl SIOCGIFFLAGS");
-    } else if(network.ifr_flags & IFF_RUNNING){
-      break;
-    }
-    struct timespec sleeptime = { .tv_nsec = 250000000 };
-    ret = nanosleep(&sleeptime, NULL);
-    if(ret == -1 and errno != EINTR){
-      perror_plus("nanosleep");
-    }
-  }
-  /* Close the socket */
-  ret = (int)TEMP_FAILURE_RETRY(close(sd));
-  if(ret == -1){
-    perror_plus("close");
-  }
-#ifdef __linux__
-  if(restore_loglevel){
-    /* Restores kernel loglevel to default */
-    ret = klogctl(7, NULL, 0);
-    if(ret == -1){
-      perror_plus("klogctl");
-    }
-  }
-#endif	/* __linux__ */
-  /* Lower privileges */
-  lower_privileges();
-  return errno;
-}
-
 int main(int argc, char *argv[]){
   AvahiSServiceBrowser *sb = NULL;
   int error;
@@ -1684,6 +1534,8 @@
   struct ifreq network;
   int sd = -1;
   bool take_down_interface = false;
+  uid_t uid;
+  gid_t gid;
   char tempdir[] = "/tmp/mandosXXXXXX";
   bool tempdir_created = false;
   AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
@@ -1869,7 +1721,11 @@
        <http://bugs.debian.org/633582> */
     
     /* Re-raise priviliges */
-    if(raise_privileges() == 0){
+    errno = 0;
+    ret = seteuid(0);
+    if(ret == -1){
+      perror_plus("seteuid");
+    } else {
       struct stat st;
       
       if(strcmp(seckey, PATHDIR "/" SECKEY) == 0){
@@ -2040,11 +1896,139 @@
   }
   
   /* If the interface is down, bring it up */
-  if((interface[0] != '\0') and (strcmp(interface, "none") != 0)){
-    ret = bring_up_interface(interface, delay);
-    if(ret){
-      errno = ret;
-      perror_plus("Failed to bring up interface");
+  if(strcmp(interface, "none") != 0){
+    if_index = (AvahiIfIndex) if_nametoindex(interface);
+    if(if_index == 0){
+      fprintf_plus(stderr, "No such interface: \"%s\"\n", interface);
+      exitcode = EX_UNAVAILABLE;
+      goto end;
+    }
+    
+    if(quit_now){
+      goto end;
+    }
+    
+    /* Re-raise priviliges */
+    errno = 0;
+    ret = seteuid(0);
+    if(ret == -1){
+      perror_plus("seteuid");
+    }
+    
+#ifdef __linux__
+    /* Lower kernel loglevel to KERN_NOTICE to avoid KERN_INFO
+       messages about the network interface to mess up the prompt */
+    ret = klogctl(8, NULL, 5);
+    bool restore_loglevel = true;
+    if(ret == -1){
+      restore_loglevel = false;
+      perror_plus("klogctl");
+    }
+#endif	/* __linux__ */
+    
+    sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
+    if(sd < 0){
+      perror_plus("socket");
+      exitcode = EX_OSERR;
+#ifdef __linux__
+      if(restore_loglevel){
+	ret = klogctl(7, NULL, 0);
+	if(ret == -1){
+	  perror_plus("klogctl");
+	}
+      }
+#endif	/* __linux__ */
+      /* Lower privileges */
+      errno = 0;
+      ret = seteuid(uid);
+      if(ret == -1){
+	perror_plus("seteuid");
+      }
+      goto end;
+    }
+    strcpy(network.ifr_name, interface);
+    ret = ioctl(sd, SIOCGIFFLAGS, &network);
+    if(ret == -1){
+      perror_plus("ioctl SIOCGIFFLAGS");
+#ifdef __linux__
+      if(restore_loglevel){
+	ret = klogctl(7, NULL, 0);
+	if(ret == -1){
+	  perror_plus("klogctl");
+	}
+      }
+#endif	/* __linux__ */
+      exitcode = EX_OSERR;
+      /* Lower privileges */
+      errno = 0;
+      ret = seteuid(uid);
+      if(ret == -1){
+	perror_plus("seteuid");
+      }
+      goto end;
+    }
+    if((network.ifr_flags & IFF_UP) == 0){
+      network.ifr_flags |= IFF_UP;
+      take_down_interface = true;
+      ret = ioctl(sd, SIOCSIFFLAGS, &network);
+      if(ret == -1){
+	take_down_interface = false;
+	perror_plus("ioctl SIOCSIFFLAGS +IFF_UP");
+	exitcode = EX_OSERR;
+#ifdef __linux__
+	if(restore_loglevel){
+	  ret = klogctl(7, NULL, 0);
+	  if(ret == -1){
+	    perror_plus("klogctl");
+	  }
+	}
+#endif	/* __linux__ */
+	/* Lower privileges */
+	errno = 0;
+	ret = seteuid(uid);
+	if(ret == -1){
+	  perror_plus("seteuid");
+	}
+	goto end;
+      }
+    }
+    /* Sleep checking until interface is running.
+       Check every 0.25s, up to total time of delay */
+    for(int i=0; i < delay * 4; i++){
+      ret = ioctl(sd, SIOCGIFFLAGS, &network);
+      if(ret == -1){
+	perror_plus("ioctl SIOCGIFFLAGS");
+      } else if(network.ifr_flags & IFF_RUNNING){
+	break;
+      }
+      struct timespec sleeptime = { .tv_nsec = 250000000 };
+      ret = nanosleep(&sleeptime, NULL);
+      if(ret == -1 and errno != EINTR){
+	perror_plus("nanosleep");
+      }
+    }
+    if(not take_down_interface){
+      /* We won't need the socket anymore */
+      ret = (int)TEMP_FAILURE_RETRY(close(sd));
+      if(ret == -1){
+	perror_plus("close");
+      }
+    }
+#ifdef __linux__
+    if(restore_loglevel){
+      /* Restores kernel loglevel to default */
+      ret = klogctl(7, NULL, 0);
+      if(ret == -1){
+	perror_plus("klogctl");
+      }
+    }
+#endif	/* __linux__ */
+    /* Lower privileges */
+    errno = 0;
+    /* Lower privileges */
+    ret = seteuid(uid);
+    if(ret == -1){
+      perror_plus("seteuid");
     }
   }
   
@@ -2091,7 +2075,6 @@
     /* Connect directly, do not use Zeroconf */
     /* (Mainly meant for debugging) */
     char *address = strrchr(connect_to, ':');
-    
     if(address == NULL){
       fprintf_plus(stderr, "No colon in address\n");
       exitcode = EX_USAGE;
@@ -2260,7 +2243,11 @@
   
   /* Re-raise priviliges */
   {
-    raise_privileges();
+    errno = 0;
+    ret = seteuid(0);
+    if(ret == -1){
+      perror_plus("seteuid");
+    }
     
     /* Take down the network interface */
     if(take_down_interface and geteuid() == 0){

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2012-05-27 07:30:49 +0000
+++ plugins.d/mandos-client.xml	2011-12-31 23:05:34 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2012-05-27">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -661,7 +661,7 @@
     <informalexample>
       <para>
 	Normal invocation needs no options, if the network interface
-	can be automatically determined:
+	is <quote>eth0</quote>:
       </para>
       <para>
 	<userinput>&COMMANDNAME;</userinput>

